<template>
	<xn-form-container
		:title="formData.id ? '编辑会员' : '增加会员'"
		:width="700"
		v-model:open="open"
		:destroy-on-close="true"
		@close="onClose"
	>
		<a-form ref="formRef" :model="formData" :rules="formRules" :label-col="labelCol" :wrapper-col="wrapperCol">
			<a-form-item label="姓名：" name="name">
				<a-input v-model:value="formData.name" placeholder="请输入姓名" allow-clear />
			</a-form-item>
			<a-form-item label="手机号：" name="phone">
				<a-input v-model:value="formData.phone" placeholder="请输入手机号" allow-clear @blur="onBlur"/>
			</a-form-item>
			<a-form-item label="糕点：" name="accountBalance" v-if="formData.id==null || formData.id==''">
				<a-input-number v-model:value="formData.accountBalance" placeholder="请输入糕点" allow-clear :min="0" :max="99999999" style="width:100%"/>
			</a-form-item>
			<a-form-item label="积分：" name="voucherBalance" v-if="formData.id==null || formData.id==''">
				<a-input-number v-model:value="formData.voucherBalance" placeholder="请输入积分" allow-clear :min="0" :max="99999999" style="width:100%"/>
			</a-form-item>
		</a-form>
		<template #footer>
			<a-button style="margin-right: 8px" @click="onClose">关闭</a-button>
			<a-button type="primary" @click="onSubmit" :loading="submitLoading">保存</a-button>
		</template>
	</xn-form-container>
</template>

<script setup name="consumptionRecordForm">
	import { cloneDeep } from 'lodash-es'
	import { required } from '@/utils/formRules'
	import bizUserApi from '@/api/biz/bizUserApi'
	// 抽屉状态
	const open = ref(false)
	const emit = defineEmits({ successful: null })
	const formRef = ref()
	// 表单数据
	const formData = ref({})
	const submitLoading = ref(false)

	const labelCol = ref({ span: 4 })
	const wrapperCol = ref({ span: 18 })

	// 打开抽屉
	const onOpen = (record) => {
		open.value = true
		if (record) {
			let recordData = cloneDeep(record)
			formData.value = Object.assign({}, recordData)
		}
	}

	const onBlur = () => {
		console.log(formData.value.phone)
		formData.value.account = formData.value.phone
		formData.value.orgId = '1543842934270394368'
		formData.value.userType = '3'
	}
	// 关闭抽屉
	const onClose = () => {
		formRef.value.resetFields()
		formData.value = {}
		open.value = false
	}
	// 默认要校验的
	const formRules = {
		name: [required('请输入姓名')],
		phone: [required('请输入手机号')],
		/*accountBalance: [required('请输入糕点')],
		voucherBalance: [required('请输入积分')],*/
	}
	// 验证并提交数据
	const onSubmit = () => {
		formRef.value
			.validate()
			.then(() => {
				submitLoading.value = true
				const formDataParam = cloneDeep(formData.value)
				bizUserApi
					.addUserSubmit(formDataParam, formDataParam.id)
					.then(() => {
						onClose()
						emit('successful')
					})
					.finally(() => {
						submitLoading.value = false
					})
			})
			.catch(() => {})
	}
	// 抛出函数
	defineExpose({
		onOpen
	})
</script>
